"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _reactRenderHook = _interopRequireDefault(require("react-render-hook"));

var _types = _interopRequireDefault(require("./types/types"));

var _domTypes = _interopRequireDefault(require("./types/dom-types"));

var deepAssertions = _interopRequireWildcard(require("./assertions/deepAssertions"));

var deepAgainstRawAssertions = _interopRequireWildcard(require("./assertions/deepAgainstRawAssertions"));

var shallowAssertions = _interopRequireWildcard(require("./assertions/shallowAssertions"));

var shallowAgainstRawAssertions = _interopRequireWildcard(require("./assertions/shallowAgainstRawAssertions"));

var jestSnapshotStandardRendererAssertions = _interopRequireWildcard(require("./assertions/jestSnapshotStandardRendererAssertions"));

var snapshotFunctionType = _interopRequireWildcard(require("./assertions/snapshotFunctionType"));

var snapshotFunctionAssertions = _interopRequireWildcard(require("./assertions/snapshotFunctionAssertions"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

module.exports = {
  name: 'unexpected-react',
  installInto: function installInto(expect) {
    expect.installPlugin(require('magicpen-prism'));

    _types["default"].installInto(expect);

    _domTypes["default"].installInto(expect);

    var mainAssertionGenerator = shallowAssertions.installInto(expect);
    shallowAgainstRawAssertions.installAsAlternative(expect, mainAssertionGenerator);
    var deepMainAssertionGenerator = deepAssertions.installInto(expect);
    deepAgainstRawAssertions.installAsAlternative(expect, deepMainAssertionGenerator);
    jestSnapshotStandardRendererAssertions.installInto(expect);
    snapshotFunctionType.installInto(expect);
    snapshotFunctionAssertions.installInto(expect);
  },
  clearAll: function clearAll() {
    _reactRenderHook["default"].clearAll();
  }
};